#!/bin/sh

set -eu

runcurl() {
    ./mktoken > token
    curl -s -H "Authorization: Bearer $(cat token)" "$@"
}

cmd="$1"
shift 1

case "$cmd" in
    update-repo)
        runcurl -X POST --data-binary @"$1" \
                -H "Content-Type: application/json" \
                https://wmf2-vcsworker.vm.liw.fi/updaterepo
        ;;

    upload-blob)
        runcurl -X PUT --data-binary @"$1" \
                -H "Content-Type: application/octet-stream" \
                https://wmf2-artifacts.vm.liw.fi/blobs/"$2"
        ;;

    get-blob)
        runcurl -X GET https://wmf2-artifacts.vm.liw.fi/blobs/"$1"
        ;;

    deploy)
        runcurl -sv -X POST --data-binary @"$1" \
                -H "Content-Type: application/json" \
                https://wmf2-deployer.vm.liw.fi/publish
        ;;

    *)
        echo "eek" 1>&2
        exit 1
        ;;
esac
